(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(require('jquery')) :
  typeof define === 'function' && define.amd ? define(['jquery'], factory) :
  (global = global || self, factory(global.jQuery));
}(this, (function ($) { 'use strict';

  $ = $ && Object.prototype.hasOwnProperty.call($, 'default') ? $['default'] : $;

  var Widget_Gallery_Carousel = function () {
    // Rearrange elements to fit bootstrap carousel structure.
    var NAME = 'widget_gallery_carousel';
    var DATA_KEY = 'mateo.gallery-carousel';
    var JQUERY_NO_CONFLICT = $.fn[NAME];
    var Default = {
      // Css classes for carousel effects.
      effects: 'slide carousel-fade',
      // Buttons labels.
      previous: 'Previous',
      next: 'Next'
    };

    var Widget_Gallery_Carousel = /*#__PURE__*/function () {
      function Widget_Gallery_Carousel(element, config) {
        this.config = $.extend(true, {}, Default, config || {});
        this.transform(element);
      }
      /**
       * Transforms wordpress media widget into bootstrap carousel component.
       * @param container
       */


      var _proto = Widget_Gallery_Carousel.prototype;

      _proto.transform = function transform(container) {
        var gallery = container.find(".gallery"); // not a gallery

        if (gallery.length === 0) {
          return;
        }

        gallery.detach();
        var base = $('<div class="carousel-base"></div>').appendTo(container);
        var icons = gallery.find(".gallery-icon"); // Append next/previous button only if there are many images.

        if (icons.length > 1) {
          icons.append("<a class=\"carousel-control-prev\" href=\"#" + container.prop('id') + "\" role=\"button\" data-slide=\"prev\">\n        <span class=\"carousel-control-prev-icon\" aria-hidden=\"true\"></span>\n        <span class=\"sr-only\">" + this.config.previous + "</span>\n        </a>\n        <a class=\"carousel-control-next\" href=\"#" + container.prop('id') + "\" role=\"button\" data-slide=\"next\">\n        <span class=\"carousel-control-next-icon\" aria-hidden=\"true\"></span>\n        <span class=\"sr-only\">" + this.config.next + "</span>\n        </a>");
        }

        gallery.addClass("carousel-inner").find(".gallery-item").addClass("carousel-item").first().addClass("active");
        base.append(gallery);
        container.addClass("carousel " + this.config.effects);
      }
      /**
       * @returns {*}
       */
      ;

      Widget_Gallery_Carousel.jQueryInterface = function jQueryInterface() {
        return this.each(function () {
          var $element = $(this);
          var data = $element.data(DATA_KEY);

          if (!data) {
            data = new Widget_Gallery_Carousel($element);
            $element.data(DATA_KEY, data);
          }
        });
      };

      return Widget_Gallery_Carousel;
    }();
    /**
     * ------------------------------------------------------------------------
     * jQuery
     * ------------------------------------------------------------------------
     */


    $.fn[NAME] = Widget_Gallery_Carousel.jQueryInterface;
    $.fn[NAME].Constructor = Widget_Gallery_Carousel;

    $.fn[NAME].noConflict = function () {
      $.fn[NAME] = JQUERY_NO_CONFLICT;
      return Widget_Gallery_Carousel.jQueryInterface;
    };

    return Widget_Gallery_Carousel;
  }();

  /**
   * Live-update changed settings in real time in the Customizer preview.
   */

  (function ($) {
    var style = $('#mateo-color-scheme-css'),
        api = wp.customize;

    if (!style.length) {
      style = $('head').append('<style type="text/css" id="mateo-color-scheme-css" />').find('#mateo-color-scheme-css');
    } // Site title.


    api('blogname', function (value) {
      value.bind(function (to) {
        $('.site-title a').text(to);
      });
    });
    api.bind('preview-ready', function () {
      // Re-load carousel initialisation script.
      api.selectiveRefresh.bind('partial-content-rendered', function (placement) {
        if (placement.addedContent && placement.partial.widgetIdParts && placement.partial.widgetIdParts.idBase === "media_gallery") {
          var gallery = $('#' + placement.partial.widgetId);

          if (gallery.length > 0) {
            new Widget_Gallery_Carousel(gallery);
          }
        }
      }); // Color Scheme CSS.

      api.preview.bind('update-color-scheme-css', function (css) {
        style.html(css);
      });
    });
  })($);

})));
