<?php
/**
 * The template for displaying the footer
 *
 * Contains the closing of the #content div and all content after.
 *
 * @link https://developer.wordpress.org/themes/basics/template-files/#template-partials
 *
 * @package mateo
 */

?>
</div>
<?php
if ( is_active_sidebar( 'sidebar-1' ) ) :
	?>
	<div class="col-12 col-lg-3 column-aside">
		<aside class="widget-area" role="complementary" aria-label="<?php esc_attr_e( 'Sidebar', 'mateo' ); ?>">
			<div class="widget-column sidebar">
				<?php dynamic_sidebar( 'sidebar-1' ); ?>
			</div>
		</aside><!-- .widget-area -->
	</div>
<?php endif; ?>

</div><!-- .row -->
</div> <!-- .#content -->
<footer id="colophon" class="page-footer">
	<div class="container-fluid footer-widget-area">
		<div class="container">
			<?php get_template_part( 'template-parts/footer/footer', 'widgets' ); ?>
		</div>
	</div>
	<div class="container-fluid footer-copyright-area">
		<div class="container footer-copyright">
			<span>
				<a href="<?php echo esc_url( home_url( '/' ) ); ?>"><?php bloginfo( 'name' ); ?></a>
			</span>
			|
			<span>
				<?php esc_html_e( 'Mateo Theme', 'mateo' ); ?>
			</span>
			<span>
				<a href="<?php echo esc_url( __( 'https://wordpress.org/', 'mateo' ) ); ?>">
					<?php esc_html_e( 'powered by WordPress', 'mateo' ); ?>
				</a>
			</span>
		</div>
	</div>
</footer>
<div class="fixed-bottom-actions">
	<?php mateo_the_post_edit_button(); ?>
</div>
<?php wp_footer(); ?>
</body>
</html>
